Docotic.Pdf library can create, edit, draw and print PDF files in .NET Core, ASP.NET, Windows Forms, WPF, Xamarin, Blazor, Unity, and HoloLense applications.

The library is a 100% managed assembly without unsafe blocks. The assembly has no external dependencies. 

### Features

Check the following articles for the most popular features of Docotic.Pdf library:
- [Extract text from PDF document in C#](https://bitmiracle.com/pdf-library/extract-text-from-pdf-in-net.aspx)
- [Compress PDF documents in C# and VB.NET](https://bitmiracle.com/pdf-library/compress-pdf.aspx)
- [Render and print PDF documents in C# and VB.NET](https://bitmiracle.com/pdf-library/draw-print-pdf.aspx)
- [Create PDF documents in C# and VB.NET](https://bitmiracle.com/pdf-library/create-pdf.aspx)
- [Convert PDF to image in C# and VB.NET](https://bitmiracle.com/pdf-library/convert-pdf-to-image.aspx)
- [OCR PDF in C# and VB.NET - how to extract text from non-searchable PDF](https://bitmiracle.com/blog/ocr-pdf-in-net)
- [Sign PDF documents in C# and VB.NET](https://bitmiracle.com/pdf-library/sign-pdf.aspx)

Docotic.Pdf library can also help you to:
* convert HTML to PDF (with free [BitMiracle.Docotic.Pdf.HtmlToPdf add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.HtmlToPdf/))
* extract images, attachments, forms data, and metadata from PDFs
* draw PDF on System.Drawing.Graphics (with free [BitMiracle.Docotic.Pdf.Gdi add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.Gdi/))
* split PDF documents into pages or combine several documents into one compound PDF document
* encrypt PDF documents and set up permissions, open protected documents, check if a PDF is encrypted
* check if two PDF documents have an equal structure
* verify if a signature in a PDF is valid.
* add images, text, and vector graphics to new and existing PDF documents
* add annotations, watermarks, attachments, actions, bookmarks, and links to PDFs
* add new PDF forms and fill existing ones
* optimize PDFs for fast web view (linearize PDFs)

### Add-ons

There are add-ons to the library:
* HtmlToPdf add-on
https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.HtmlToPdf/

* Layout add-on
https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.Layout/

* Gdi add-on
https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.Gdi/

### Free time-limited license
You can get a free time-limited license [via the form on our site](https://bitmiracle.com/pdf-library/).

### Free PDF Library offer
We offer [free licenses](https://bitmiracle.com/pdf-library/free-pdf-library.aspx) for eligible projects and/or people.